/*
 * Hello World - Tcl Erweiterung
 */

#include <tcl.h>

/* Vorwrtsdeklaration des Kommandos. */
int Hallo_Kommando(ClientData cdata, Tcl_Interp *interp, int objc,
      Tcl_Obj * CONST objv[]);

/*
 * Initialisierung der Erweiterung,
 * sie wird beim Laden vom Interpreter 
 * aufgerufen
 * @param interp, Pointer auf den Interpreter
 * @return Status, TCL_OK oder TCL_ERROR
 */
int Hallo_Init(Tcl_Interp *interp)
{
#ifdef USE_TCL_STUBS
  if (Tcl_InitStubs(interp, "8.1", 0) == 0L) {
    return TCL_ERROR;
  }
#endif

  /* erzeugt das Kommando "hallo" */
  Tcl_CreateObjCommand(interp, "hallo", Hallo_Kommando, NULL, NULL);
  return TCL_OK;
}

/*
 * Die Funktion hinter dem hallo-Kommando
 * @param interp, der Interpreter
 * @param objc, Anzahl der Eingabeobjekte
 * @param objv[], Array mit Eingabeobjekten
 * @return Status, TCL_OK oder TCL_ERROR
 */
int Hallo_Kommando(ClientData cdata, Tcl_Interp *interp, int objc,
                  Tcl_Obj * CONST objv[])
{
  Tcl_Obj* retval = Tcl_NewStringObj("Hallo Welt!", -1);
  Tcl_SetObjResult(interp, retval);
  return TCL_OK;
}



